/*
 * ExNihilo 3D Engine
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Please read AUTHORS file !!!
 * 
 * $Id: ExManagerInterface.h,v 1.5 2002/08/01 18:45:56 data Exp $
 *
 */

#ifndef __EXMANAGERINTERFACE_H__
#define __EXMANAGERINTERFACE_H__
//--------------------------------
// File to include
//--------------------------------
#include "ExDefine.h"
#include "ExMath.h"
#include "InputActionList.h"
#include "ExManagerId.h"
#include "ExManagerWindow.h"
#include "ExManagerTexture.h"
#include "ExCInterface.h"
//--------------------------------
class ExManagerInterface
{
private:
//--------------------------------
// Variable
//--------------------------------
	ExManagerId			*ManagerId;
	ExManagerWindow		*ManagerWindow;
	ExManagerTexture	*ManagerTexture;

	std::vector<ExCInterface> m_VecInterface;
	std::vector<ExCInterface>::iterator m_ItVecInterface;
	
	

public:
	ExManagerInterface(void);
	~ExManagerInterface(void);
//--------------------------------
// Methode
//--------------------------------
	std::ostrstream *Consol;
	void (*WriteToConsol)(const char *Label);

	inline void SetManagerId(ExManagerId *Id){ManagerId	= Id;}
	inline void SetManagerWindow(ExManagerWindow *Window){ManagerWindow = Window;}
	inline void SetManagerTexture(ExManagerTexture * Texture){ManagerTexture = Texture;}

	void ShowRegion(void);
	void HideRegion(void);

	void init(void);
	void Reset(void);

	void DrawInterface(void);
	bool LoadInterface(const char * FileName);
	SAction InputCommand(int command,int mousex,int mousey);
	int EnableInterface(char *param);
	int DisableInterface(char *param);
	int EnableAllInterface(void);
	int DisableAllInterface(void);
	int GetNumberEnableInterface(void);
	void ListInterface(void);
};
#endif //__EXMANAGERINTERFACE_H__
